// Copyright (C) 2021-2024 Bundesministerium des Innern und für Heimat, Referat DG II 6, Maßnahmen Enterprise Resource Management und Elektronische Verwaltungsarbeit
//
// SPDX-License-Identifier: MPL-2.0

// tslint:disable
/**
 * eGesetzgebung Platform
 * This is the rest interface offered by the eGesetzgebung Platform backend.  Please provide __JW Access Token__ using button \'Authorize\' to access protected endpoints. Use the following instructions to get token:  1. on CMD/Bash/Terminal: ```curl -d \"client_id=user-management\" -d \"client_secret=INSERT_IAM_SECRET\" -d \"grant_type=password&username=INSERT_USER_EMAIL&password=INSERT_USER_PASSWORD\" \"INSERT_IAM_URL/realms/bund/protocol/openid-connect/token\"``` 2. copy access_token (without quotes, you can use jq or other tools to extract this value automatically) 3. insert value into \'JWToken\' field under \'Authorize\' and press \'Authorize\' 4. now you should have access to user protected endpoint  __FYI:__ token expires after 60 seconds. On non-production systems only a warning is displayed so you can work smoothly, but on production systems you have to frequently provide a new token.
 *
 * The version of the OpenAPI document: 9.0.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import type { Observable } from 'rxjs';
import type { AjaxResponse } from 'rxjs/ajax';
import { BaseAPI, throwIfNullOrUndefined, encodeURI } from '../runtime';
import type { OperationOpts, HttpHeaders, HttpQuery } from '../runtime';
import type {
    DrucksachennummerReportTyp,
    EgfaErfuellungItemNormadressat,
    EgfaModuleType,
    EntwurfstypType,
    ExportType,
    FileEntityListResponseDTO,
    FileEntityModifyDTO,
    FileEntityResponseDTO,
} from '../models';

export interface CreateBundestagsdrucksachennummernReportRequest {
    reportTyp: DrucksachennummerReportTyp;
}

export interface CreateEgfaErfuellungsaufwandCsvSummaryRequest {
    egfaId: string;
    normadressat: EgfaErfuellungItemNormadressat;
}

export interface CreateEgfaModulePdfSummaryRequest {
    egfaId: string;
    moduleType: EgfaModuleType;
}

export interface CreateEgfaPdfSummaryRequest {
    egfaId: string;
}

export interface CreateFileRequest {
    file: Blob;
    fileName: string;
    entwurfStatusType: EntwurfstypType;
    abstimmungId: string;
}

export interface CreateRegelungsvorhabenPdfSummaryRequest {
    rvId: string;
}

export interface DeleteFileRequest {
    fileId: string;
}

export interface DeleteFilesRequest {
    abstimmungId: string;
}

export interface DownloadAbstimmungFileAsZipRequest {
    abstimmungId: string;
}

export interface DownloadAbstimmungTeilnehmerFilesAsZipRequest {
    abstimmungId: string;
}

export interface DownloadAbstimmungTeilnehmersFilesAsZipRequest {
    abstimmungId: string;
}

export interface DownloadFileRequest {
    fileId: string;
}

export interface DownloadRvFileRequest {
    fileId: string;
}

export interface GetErstellerFilesRequest {
    abstimmungId: string;
}

export interface GetTagesausdruck1Request {
    start: string;
    end: string;
    type?: ExportType;
}

export interface ModifyFileRequest {
    id: string;
    fileEntityModifyDTO: FileEntityModifyDTO;
}

/**
 * no description
 */
export class FileControllerApi extends BaseAPI {

    /**
     * Erstellt eine CSV-Datei der vergebenen Bundesrats-Drucksachennummern. BR kann keine Nummern reservieren.
     * BR-Drucksachennummern-Report exportieren. Export ist sortiert absteigend nach Jahr und laufender Drucksachen-Nummer.
     */
    createBundesratsdrucksachennummernReport(): Observable<Blob>
    createBundesratsdrucksachennummernReport(opts?: OperationOpts): Observable<AjaxResponse<Blob>>
    createBundesratsdrucksachennummernReport(opts?: OperationOpts): Observable<Blob | AjaxResponse<Blob>> {
        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<Blob>({
            url: '/file/brdrucksachennummerexport/csv',
            method: 'GET',
            headers,
            responseType: 'blob',
        }, opts?.responseOpts);
    };

    /**
     * Erstellt eine CSV-Datei der reservierten oder vergebenen Bundestags-Drucksachennummern.
     * BT-Drucksachennummern-Report exportieren.
     */
    createBundestagsdrucksachennummernReport({ reportTyp }: CreateBundestagsdrucksachennummernReportRequest): Observable<Blob>
    createBundestagsdrucksachennummernReport({ reportTyp }: CreateBundestagsdrucksachennummernReportRequest, opts?: OperationOpts): Observable<AjaxResponse<Blob>>
    createBundestagsdrucksachennummernReport({ reportTyp }: CreateBundestagsdrucksachennummernReportRequest, opts?: OperationOpts): Observable<Blob | AjaxResponse<Blob>> {
        throwIfNullOrUndefined(reportTyp, 'reportTyp', 'createBundestagsdrucksachennummernReport');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<Blob>({
            url: '/file/drucksachennummerexport/{reportTyp}/csv'.replace('{reportTyp}', encodeURI(reportTyp)),
            method: 'GET',
            headers,
            responseType: 'blob',
        }, opts?.responseOpts);
    };

    /**
     * Erstellt eine CSV-Datei, die eine Zusammenfassung für einen Normadressaten enthält.
     * Normadressat Zusammenfassung exportieren
     */
    createEgfaErfuellungsaufwandCsvSummary({ egfaId, normadressat }: CreateEgfaErfuellungsaufwandCsvSummaryRequest): Observable<Blob>
    createEgfaErfuellungsaufwandCsvSummary({ egfaId, normadressat }: CreateEgfaErfuellungsaufwandCsvSummaryRequest, opts?: OperationOpts): Observable<AjaxResponse<Blob>>
    createEgfaErfuellungsaufwandCsvSummary({ egfaId, normadressat }: CreateEgfaErfuellungsaufwandCsvSummaryRequest, opts?: OperationOpts): Observable<Blob | AjaxResponse<Blob>> {
        throwIfNullOrUndefined(egfaId, 'egfaId', 'createEgfaErfuellungsaufwandCsvSummary');
        throwIfNullOrUndefined(normadressat, 'normadressat', 'createEgfaErfuellungsaufwandCsvSummary');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<Blob>({
            url: '/file/egfaexport/{egfaId}/erfuellungsaufwand/{normadressat}/csv'.replace('{egfaId}', encodeURI(egfaId)).replace('{normadressat}', encodeURI(normadressat)),
            method: 'GET',
            headers,
            responseType: 'blob',
        }, opts?.responseOpts);
    };

    /**
     * Erzeugt eine eGFA Modul Zusammenfassung als Export
     * eGFA Modul Zusammenfassung exportieren
     */
    createEgfaModulePdfSummary({ egfaId, moduleType }: CreateEgfaModulePdfSummaryRequest): Observable<Blob>
    createEgfaModulePdfSummary({ egfaId, moduleType }: CreateEgfaModulePdfSummaryRequest, opts?: OperationOpts): Observable<AjaxResponse<Blob>>
    createEgfaModulePdfSummary({ egfaId, moduleType }: CreateEgfaModulePdfSummaryRequest, opts?: OperationOpts): Observable<Blob | AjaxResponse<Blob>> {
        throwIfNullOrUndefined(egfaId, 'egfaId', 'createEgfaModulePdfSummary');
        throwIfNullOrUndefined(moduleType, 'moduleType', 'createEgfaModulePdfSummary');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<Blob>({
            url: '/file/egfaexport/{egfaId}/{moduleType}/pdf'.replace('{egfaId}', encodeURI(egfaId)).replace('{moduleType}', encodeURI(moduleType)),
            method: 'GET',
            headers,
            responseType: 'blob',
        }, opts?.responseOpts);
    };

    /**
     * Erzeugt eine eGFA Zusammenfassung als Export
     * eGFA Zusammenfassung exportieren
     */
    createEgfaPdfSummary({ egfaId }: CreateEgfaPdfSummaryRequest): Observable<Blob>
    createEgfaPdfSummary({ egfaId }: CreateEgfaPdfSummaryRequest, opts?: OperationOpts): Observable<AjaxResponse<Blob>>
    createEgfaPdfSummary({ egfaId }: CreateEgfaPdfSummaryRequest, opts?: OperationOpts): Observable<Blob | AjaxResponse<Blob>> {
        throwIfNullOrUndefined(egfaId, 'egfaId', 'createEgfaPdfSummary');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<Blob>({
            url: '/file/egfaexport/{egfaId}/pdf'.replace('{egfaId}', encodeURI(egfaId)),
            method: 'GET',
            headers,
            responseType: 'blob',
        }, opts?.responseOpts);
    };

    /**
     * Legt eine hochgeladene Datei an, und speichert die Metadata in die Datenbank.
     * Anlegen einer hochgeladenen Datei (E/T)
     */
    createFile({ file, fileName, entwurfStatusType, abstimmungId }: CreateFileRequest): Observable<FileEntityResponseDTO>
    createFile({ file, fileName, entwurfStatusType, abstimmungId }: CreateFileRequest, opts?: OperationOpts): Observable<AjaxResponse<FileEntityResponseDTO>>
    createFile({ file, fileName, entwurfStatusType, abstimmungId }: CreateFileRequest, opts?: OperationOpts): Observable<FileEntityResponseDTO | AjaxResponse<FileEntityResponseDTO>> {
        throwIfNullOrUndefined(file, 'file', 'createFile');
        throwIfNullOrUndefined(fileName, 'fileName', 'createFile');
        throwIfNullOrUndefined(entwurfStatusType, 'entwurfStatusType', 'createFile');
        throwIfNullOrUndefined(abstimmungId, 'abstimmungId', 'createFile');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        const formData = new FormData();
        if (file !== undefined) { formData.append('file', file as any); }
        if (fileName !== undefined) { formData.append('fileName', fileName as any); }
        if (entwurfStatusType !== undefined) { formData.append('entwurfStatusType', entwurfStatusType as any); }
        if (abstimmungId !== undefined) { formData.append('abstimmungId', abstimmungId as any); }

        return this.request<FileEntityResponseDTO>({
            url: '/file/upload',
            method: 'POST',
            headers,
            body: formData,
        }, opts?.responseOpts);
    };

    /**
     * Erzeugt eine Regelungsvorhaben Zusammenfassung als Export
     * Regelungsvorhaben Zusammenfassung exportieren
     */
    createRegelungsvorhabenPdfSummary({ rvId }: CreateRegelungsvorhabenPdfSummaryRequest): Observable<Blob>
    createRegelungsvorhabenPdfSummary({ rvId }: CreateRegelungsvorhabenPdfSummaryRequest, opts?: OperationOpts): Observable<AjaxResponse<Blob>>
    createRegelungsvorhabenPdfSummary({ rvId }: CreateRegelungsvorhabenPdfSummaryRequest, opts?: OperationOpts): Observable<Blob | AjaxResponse<Blob>> {
        throwIfNullOrUndefined(rvId, 'rvId', 'createRegelungsvorhabenPdfSummary');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<Blob>({
            url: '/file/regelungsvorhabenexport/{rvId}/pdf'.replace('{rvId}', encodeURI(rvId)),
            method: 'GET',
            headers,
            responseType: 'blob',
        }, opts?.responseOpts);
    };

    /**
     * Löscht eine zuvor vom aktuellen User hochgeladene Datei
     * Datei löschen (E/T)
     */
    deleteFile({ fileId }: DeleteFileRequest): Observable<void>
    deleteFile({ fileId }: DeleteFileRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    deleteFile({ fileId }: DeleteFileRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(fileId, 'fileId', 'deleteFile');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        const query: HttpQuery = { // required parameters are used directly since they are already checked by throwIfNullOrUndefined
            'fileId': fileId,
        };

        return this.request<void>({
            url: '/file',
            method: 'DELETE',
            headers,
            query,
        }, opts?.responseOpts);
    };

    /**
     * Löscht alle Dateien die der aktuelle User zu einer Abstimmung hochgeladen hat
     * Abstimmungsdateien löschen (E/T)
     */
    deleteFiles({ abstimmungId }: DeleteFilesRequest): Observable<void>
    deleteFiles({ abstimmungId }: DeleteFilesRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    deleteFiles({ abstimmungId }: DeleteFilesRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(abstimmungId, 'abstimmungId', 'deleteFiles');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        const query: HttpQuery = { // required parameters are used directly since they are already checked by throwIfNullOrUndefined
            'abstimmungId': abstimmungId,
        };

        return this.request<void>({
            url: '/file/deleteall',
            method: 'DELETE',
            headers,
            query,
        }, opts?.responseOpts);
    };

    /**
     * Lädt alle Dateien eines Abstimmungseinleiters als ZIP-Datei herunter.
     * ZIP Datei Herunterladen.
     */
    downloadAbstimmungFileAsZip({ abstimmungId }: DownloadAbstimmungFileAsZipRequest): Observable<Blob>
    downloadAbstimmungFileAsZip({ abstimmungId }: DownloadAbstimmungFileAsZipRequest, opts?: OperationOpts): Observable<AjaxResponse<Blob>>
    downloadAbstimmungFileAsZip({ abstimmungId }: DownloadAbstimmungFileAsZipRequest, opts?: OperationOpts): Observable<Blob | AjaxResponse<Blob>> {
        throwIfNullOrUndefined(abstimmungId, 'abstimmungId', 'downloadAbstimmungFileAsZip');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<Blob>({
            url: '/file/fullexport/{abstimmungId}'.replace('{abstimmungId}', encodeURI(abstimmungId)),
            method: 'GET',
            headers,
            responseType: 'blob',
        }, opts?.responseOpts);
    };

    /**
     * Lädt alle Dateien eines Abstimmungsteilnehmers als ZIP-Datei herunter.
     * ZIP Datei herunterladen
     */
    downloadAbstimmungTeilnehmerFilesAsZip({ abstimmungId }: DownloadAbstimmungTeilnehmerFilesAsZipRequest): Observable<Blob>
    downloadAbstimmungTeilnehmerFilesAsZip({ abstimmungId }: DownloadAbstimmungTeilnehmerFilesAsZipRequest, opts?: OperationOpts): Observable<AjaxResponse<Blob>>
    downloadAbstimmungTeilnehmerFilesAsZip({ abstimmungId }: DownloadAbstimmungTeilnehmerFilesAsZipRequest, opts?: OperationOpts): Observable<Blob | AjaxResponse<Blob>> {
        throwIfNullOrUndefined(abstimmungId, 'abstimmungId', 'downloadAbstimmungTeilnehmerFilesAsZip');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<Blob>({
            url: '/file/teilnehmerantwortexport/{abstimmungId}'.replace('{abstimmungId}', encodeURI(abstimmungId)),
            method: 'GET',
            headers,
            responseType: 'blob',
        }, opts?.responseOpts);
    };

    /**
     * Lädt alle Dateien aller Abstimmungsteilnehmer als ZIP-Datei herunter.
     * ZIP Datei Herunterladen.
     */
    downloadAbstimmungTeilnehmersFilesAsZip({ abstimmungId }: DownloadAbstimmungTeilnehmersFilesAsZipRequest): Observable<Blob>
    downloadAbstimmungTeilnehmersFilesAsZip({ abstimmungId }: DownloadAbstimmungTeilnehmersFilesAsZipRequest, opts?: OperationOpts): Observable<AjaxResponse<Blob>>
    downloadAbstimmungTeilnehmersFilesAsZip({ abstimmungId }: DownloadAbstimmungTeilnehmersFilesAsZipRequest, opts?: OperationOpts): Observable<Blob | AjaxResponse<Blob>> {
        throwIfNullOrUndefined(abstimmungId, 'abstimmungId', 'downloadAbstimmungTeilnehmersFilesAsZip');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<Blob>({
            url: '/file/teilnehmerexport/{abstimmungId}'.replace('{abstimmungId}', encodeURI(abstimmungId)),
            method: 'GET',
            headers,
            responseType: 'blob',
        }, opts?.responseOpts);
    };

    /**
     * Lädt eine Datei herunter.
     * Datei herunterladen (E/T).
     */
    downloadFile({ fileId }: DownloadFileRequest): Observable<Blob>
    downloadFile({ fileId }: DownloadFileRequest, opts?: OperationOpts): Observable<AjaxResponse<Blob>>
    downloadFile({ fileId }: DownloadFileRequest, opts?: OperationOpts): Observable<Blob | AjaxResponse<Blob>> {
        throwIfNullOrUndefined(fileId, 'fileId', 'downloadFile');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<Blob>({
            url: '/file/download/{fileId}'.replace('{fileId}', encodeURI(fileId)),
            method: 'GET',
            headers,
            responseType: 'blob',
        }, opts?.responseOpts);
    };

    /**
     * Lädt eine RV-Datei herunter
     * RV-Datei herunterladen (E/T).
     */
    downloadRvFile({ fileId }: DownloadRvFileRequest): Observable<Blob>
    downloadRvFile({ fileId }: DownloadRvFileRequest, opts?: OperationOpts): Observable<AjaxResponse<Blob>>
    downloadRvFile({ fileId }: DownloadRvFileRequest, opts?: OperationOpts): Observable<Blob | AjaxResponse<Blob>> {
        throwIfNullOrUndefined(fileId, 'fileId', 'downloadRvFile');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<Blob>({
            url: '/file/download/rv/{fileId}'.replace('{fileId}', encodeURI(fileId)),
            method: 'GET',
            headers,
            responseType: 'blob',
        }, opts?.responseOpts);
    };

    /**
     * Liefert die Liste der Files der Ersteller zu einer Abstimmung hochgeladen hat.
     * Lädt die Dateien des Erstellers zu einer Abstimmung (E/T)
     */
    getErstellerFiles({ abstimmungId }: GetErstellerFilesRequest): Observable<FileEntityListResponseDTO>
    getErstellerFiles({ abstimmungId }: GetErstellerFilesRequest, opts?: OperationOpts): Observable<AjaxResponse<FileEntityListResponseDTO>>
    getErstellerFiles({ abstimmungId }: GetErstellerFilesRequest, opts?: OperationOpts): Observable<FileEntityListResponseDTO | AjaxResponse<FileEntityListResponseDTO>> {
        throwIfNullOrUndefined(abstimmungId, 'abstimmungId', 'getErstellerFiles');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<FileEntityListResponseDTO>({
            url: '/file/abstimmung/{abstimmungId}/erstellerFiles'.replace('{abstimmungId}', encodeURI(abstimmungId)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Erstellt ein PDF für den Tagesausdruck des ausgewählten Zeitraums. Ist kein Zeitraum angegeben, dann für den aktuellen Tag.
     * ERstellt den Tagesausdruck
     */
    getTagesausdruck1({ start, end, type }: GetTagesausdruck1Request): Observable<Blob>
    getTagesausdruck1({ start, end, type }: GetTagesausdruck1Request, opts?: OperationOpts): Observable<AjaxResponse<Blob>>
    getTagesausdruck1({ start, end, type }: GetTagesausdruck1Request, opts?: OperationOpts): Observable<Blob | AjaxResponse<Blob>> {
        throwIfNullOrUndefined(start, 'start', 'getTagesausdruck1');
        throwIfNullOrUndefined(end, 'end', 'getTagesausdruck1');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        const query: HttpQuery = { // required parameters are used directly since they are already checked by throwIfNullOrUndefined
            'start': start,
            'end': end,
        };

        if (type != null) { query['type'] = type; }

        return this.request<Blob>({
            url: '/file/tagesausdruck',
            method: 'GET',
            headers,
            query,
            responseType: 'blob',
        }, opts?.responseOpts);
    };

    /**
     * Bearbeitet eine Datei die der aktuelle User hochgeladen hat
     * Ändert den Namen einer Datei (E/T)
     */
    modifyFile({ id, fileEntityModifyDTO }: ModifyFileRequest): Observable<FileEntityResponseDTO>
    modifyFile({ id, fileEntityModifyDTO }: ModifyFileRequest, opts?: OperationOpts): Observable<AjaxResponse<FileEntityResponseDTO>>
    modifyFile({ id, fileEntityModifyDTO }: ModifyFileRequest, opts?: OperationOpts): Observable<FileEntityResponseDTO | AjaxResponse<FileEntityResponseDTO>> {
        throwIfNullOrUndefined(id, 'id', 'modifyFile');
        throwIfNullOrUndefined(fileEntityModifyDTO, 'fileEntityModifyDTO', 'modifyFile');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<FileEntityResponseDTO>({
            url: '/file/{id}'.replace('{id}', encodeURI(id)),
            method: 'PUT',
            headers,
            body: fileEntityModifyDTO,
        }, opts?.responseOpts);
    };

}
